#include <ctime>
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define mp make_pair
#define pb push_back
#define F first
#define S second
#define debug(x) std::cout << #x << ": " << x << "\n"
#define all(v) v.begin(), v.end()
#define li(i,a,b) for (int (i) = (a); (i) < (b); (i)++)
#define endl '\n'
#define mem(name,val) memset(name,val,sizeof(name))
#define min(a,b) (a<=b ? a : b)
#define max(a,b) (a>=b ? a : b)
//using u64 = uint64_t;
//using u128 = __uint128_t;

int inf = 2e9;
struct sliding_window{
    deque<pair<int,int>> d;
    int l, r;
    
    sliding_window(){
        l = r = 0;
    }
    
    void push_back(int x){
        while(!d.empty() && d.back().first >= x) d.pop_back();
        d.emplace_back(x,r);
        ++r;
    }
    
    void pop_front(){
        if(d.front().second == l) d.pop_front();
        ++l;
    }
    
    int get_min(){
        return d.empty() ? inf : d.front().first;
    }
};

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    int n,m;
    cin>>n>>m;
    int a[n];
    li(i,0,n)cin>>a[i];
    vector<vector<int>> dp(n+2,vector<int>(n+2, 0));
    vector<sliding_window> diag(n+3);

    for(int i = n-1; i>=0; i--){
        int lastEdit = i;
        for(int j = i+1; j<=n; j++){
            if(j-i > m){
                int id = i+m-j+n;

                int bot = dp[i+m][j];
                int top = dp[i][j-m];

                int res1 = diag[id].get_min();
                diag[id].pop_front();
                int res2 = min(diag[id].get_min(),top);
                diag[id].push_back(top);

                lastEdit = j-m;

                res1+=a[i];
                res2+=a[j-1];
                dp[i][j] = max(res1, res2);
            }
            else{
                dp[i][j] = max(a[i],a[j-1]);
            }
        }
        for(int j = lastEdit+1; j<=n; j++){
            diag[i-j+n].push_back(dp[i][j]);
        }
    }

    for(int k = 0; k<m; k++){
        int res = INT_MAX;
        for(int x = 0; x<=k; x++){
            res = min(res, dp[x][n-(k-x)]);
        }
        cout<<res<<" ";
    }

    return 0;
}