#include <iostream>
#include <vector>
#include <stack>
#include <utility>
#include <algorithm>
using namespace std;

long long ktielement(vector<long long> &a, int k, int l, int d)
{
  while(true)
  {
    int m = l + 1;
    for(int i = l + 1; i <= d; i++)
    {
      if (a[i] < a[l])
      {
        swap(a[i],a[m]);
        m++;
      }
    }
    m--;
    swap(a[l],a[m]);
    if(m==k)return a[m];
    else if(m<k)l=m+1;
    else d=m-1;
  }
}
vector<int> dfs(int start, int end, const vector<vector<int>> &adjacency_list, int n)
{
  vector<bool> visited(n+1, false);
  stack<pair<int,vector<int>>> st;
  st.push({start,{start}});
  while (!st.empty()) 
  {
    auto [tr,put]=st.top();
    st.pop();
    if (tr==end) 
    {
      return put;
    }
    visited[tr]=true;
    for (auto komsija:adjacency_list[tr]) 
    {
      if (!visited[komsija])
      {
        vector<int> put1=put;
        put1.push_back(komsija);
        st.push({komsija,put1});
      }
    }
  }
  return {};
}
int main() {
    int n,m,p,q;
    scanf("%d %d %d %d",&n,&m,&q,&p);
    vector<vector<int>> adjacency_list(n+1);
    vector<long long>niz(n);
    for(int i=0;i<n;i++)scanf("%lld",&niz[i]);
    for (int i=0;i<m;i++)
    {
        int u, v;
        scanf("%d %d",&u,&v);
        adjacency_list[u].push_back(v);
        adjacency_list[v].push_back(u);
    }
    vector<long long> ans(1);
    int a1,b1,a,b;
    for(int i=0;i<q;i++)
    {
      scanf("%d %d", &a1,&b1);
      a=(a1+ans.back()*p-1)%n+1;
      b=(b1+ans.back()*p-1)%n+1;
      vector<int>indeksi;
      indeksi=dfs(a,b,adjacency_list,n);
      int d=indeksi.size();
      vector<long long> put(d);
      for(int i=0;i<d;i++)put[i]=niz[indeksi[i]-1];
      long long med;
      if(d%2==1)
      {
        med=ktielement(put,(d+1)/2-1,0,d-1);
      }
      else
      {
        med=ktielement(put,d/2-1,0,d-1);
      }
      printf("%lld\n",med);
      ans.push_back(med);
    }
    return 0;
}