#include <stdio.h>
#include <stdlib.h>

long long n; 
long long mat[n+1][n+1];  
int used[n+1];            
long long path[n+1];      

int dfs(long long i, long long step) {
    path[step] = i;         
    used[i] = 1;            

    if (step == n) {  
        if (mat[i][1] == 1) { 
            path[n+1] = 1;   
            return 1;
        }
        return 0;
    }

    for (long long k = 1; k <= n; k++) {
        if (mat[i][k] && !used[k]) {  
            if (dfs(k, step + 1)) {
                return 1;
            }
        }
    }

    used[i] = 0;  
    return 0;
}

int main()
{
    long long a, b, c; 
    scanf("%lld", &n); 
    
    for (long long i = 1; i <= n; i++) 
        for (long long j = 1; j <= n; j++) 
            mat[i][j] = 0;
    
    mat[1][2] = mat[2][1] = mat[1][3] = mat[3][1] = mat[2][3] = mat[3][2] = 1;
    mat[1][4] = mat[4][1] = mat[2][4] = mat[4][2] = mat[3][4] = mat[4][3] = 1;
    
    long long j = 5;
    
    for (long long i = 0; i < n - 4; i++) {
        scanf("%lld %lld %lld", &a, &b, &c); 
        mat[j][a] = mat[a][j] = mat[j][b] = mat[b][j] = mat[c][j] = mat[j][c] = 1;
        j++; 
    }

    for (long long i = 1; i <= n; i++) {
        used[i] = 0; 
    }
    
    if (dfs(1, 1)) {  
        for (long long i = 1; i <= n + 1; i++) {
            printf("%lld ", path[i]);
        }
        printf("\n");
    } else {
        printf("-1\n");  
    }

    return 0;
}