#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

int main() {
    ll a, b;
    cin >> a >> b;

    auto izracunajProsek = [](ll x, ll y, ll z) {
        return (x + y + z) / 3.0;
    };

    auto izracunajMedijanu = [](ll x, ll y, ll z) {
        ll najmanji = min({x, y, z});
        ll najveci = max({x, y, z});
        return x + y + z - najmanji - najveci;
    };

    ll donjaGranica = 1, gornjaGranica = 1e18;
    ll maksimalnoC = 1;

    while (donjaGranica <= gornjaGranica) {
        ll sredina = donjaGranica + (gornjaGranica - donjaGranica) / 2;

        // Racunamo prosek i medijanu za trenutnu vrednost sredina
        double prosek = izracunajProsek(a, b, sredina);
        ll medijana = izracunajMedijanu(a, b, sredina);

        if (prosek <= medijana) {
            maksimalnoC = sredina;
            donjaGranica = sredina + 1;
        } else {
            gornjaGranica = sredina - 1;
        }
    }

    cout << maksimalnoC << endl;

    return 0;
}