using System;

namespace Aplikacija
{
    class Program
    {
        static void nulaijed(int[,] niz, string[] str0, string[] str1, int n, int j = 0)
        {
            if (j == n) return;
            niz[0, j] = int.Parse(str0[j]) % 2;
            niz[1, j] = int.Parse(str1[j]) % 2;
            nulaijed(niz, str0, str1, n, j + 1);
        }

        static void unazad(int[,] niz, int z)
        {
            if (z < 0 || niz[0, z] == niz[1, z]) return;
            if (niz[0, z + 1] != niz[1, z])
            {
                int temp = niz[0, z];
                niz[0, z] = niz[1, z];
                niz[1, z] = temp;
            }
            unazad(niz, z - 1);
        }

        static void unapred(int[,] niz, int j, int n)
        {
            if (j == n) return;
            if (niz[1, j - 1] != niz[0, j])
            {
                int t = niz[0, j];
                niz[0, j] = niz[1, j];
                niz[1, j] = t;
            }
            unapred(niz, j + 1, n);
        }

        static int srecica(int[,] niz, int j, int n, int sreca)
        {
            if (j >= n - 1) return sreca;
            if (niz[1, j] == niz[0, j + 1]) sreca++;
            return srecica(niz, j + 1, n, sreca);
        }

        static void obradi(int[,] niz, int j, int n, ref int sreca)
        {
            if (j == n) return;
            if (niz[0, j] == niz[1, j])
            {
                sreca++;
                unazad(niz, j - 1);
            }
            obradi(niz, j + 1, n, ref sreca);
        }

        static void Main(string[] args)
        {
            int testovi = int.Parse(Console.ReadLine()); 
            int[] mat = new int[testovi];

            for (int i = 0; i < testovi; i++)
            {
                int m = int.Parse(Console.ReadLine()); 
                int[,] niz = new int[2, m];
                string[] str0 = Console.ReadLine().Split(' ');
                string[] str1 = Console.ReadLine().Split(' ');

                nulaijed(niz, str0, str1, m);
                int sreca = 0;
                obradi(niz, 0, m, ref sreca);

                if (m > 1)
                {
                    unapred(niz, 1, m);
                }

                mat[i] = srecica(niz, 0, m, sreca);
            }

            foreach (int rezultat in mat)
            {
                Console.WriteLine(rezultat);
            }
        }
    }
}